 /*
  * Copyright (C), 2018-2021
  * Project: starter
  * FileName: AccessibleFormulaVueEditor
  * Author:   Louis
  * Date:     2021/11/26 9:09
  */
 package com.fr.plugin.hrjf.accessibles;

 import com.fr.base.BaseFormula;
 import com.fr.design.dialog.BasicDialog;
 import com.fr.design.dialog.DialogActionAdapter;
 import com.fr.design.formula.FormulaFactory;
 import com.fr.design.formula.UIFormula;
 import com.fr.design.mainframe.widget.wrappers.FormulaWrapper;

 import javax.swing.*;

 /**
  * <Function Description><br>
  * <AccessibleFormulaVueEditor>
  *
  * @author fr.open
  * @since 1.0.0
  */
 public class AccessibleFormulaVueEditor extends BaseAccessibleVueEditor {
     private UIFormula formulaPane;

     public AccessibleFormulaVueEditor() {
         super(new FormulaWrapper(), new FormulaWrapper(), true);
     }

     protected void showEditorPane() {
         if (this.formulaPane == null) {
             this.formulaPane = FormulaFactory.createFormulaPane();
         }

         BasicDialog var1 = this.formulaPane.showLargeWindow(SwingUtilities.getWindowAncestor(this), new DialogActionAdapter() {
             public void doOk() {
                 AccessibleFormulaVueEditor.this.setValue(AccessibleFormulaVueEditor.this.formulaPane.update());
                 AccessibleFormulaVueEditor.this.fireStateChanged();
             }
         });
         this.formulaPane.populate((BaseFormula) this.getValue());
         var1.setVisible(true);
     }
 }