 /*
  * Copyright (C), 2018-2021
  * Project: starter
  * FileName: SsoConfig
  * Author:   Louis
  * Date:     2021/3/30 9:38
  */
 package com.fr.plugin.hrjf.config;

 import com.fanruan.api.util.StringKit;
 import com.fr.config.*;
 import com.fr.config.holder.Conf;
 import com.fr.config.holder.factory.Holders;

 /**
  * <Function Description><br>
  * <SsoConfig>
  *
  * @author fr.open
  * @since 1.0.0
  */
 @Visualization(category = "Plugin-hrjf_Group")
 public class SsoConfig extends DefaultConfiguration {
     public static final String PLUGIN_ID = "com.fr.plugin.hrjf.date";

     private static volatile SsoConfig config = null;
     @Identifier(value = "uriBase", name = "Plugin-hrjf_Config_UriBase", description = "Plugin-hrjf_Config_UriBase_Description", status = Status.SHOW)
     private final Conf<String> uriBase = Holders.simple(StringKit.EMPTY);
     @Identifier(value = "clientId", name = "Plugin-hrjf_Config_ClientId", description = "Plugin-hrjf_Config_ClientId_Description", status = Status.SHOW)
     private Conf<String> clientId = Holders.simple(StringKit.EMPTY);
     @Identifier(value = "clientSecret", name = "Plugin-hrjf_Config_ClientSecret", description = "Plugin-hrjf_Config_ClientSecret_Description", status = Status.SHOW)
     private Conf<String> clientSecret = Holders.simple(StringKit.EMPTY);
     @Identifier(value = "frUri", name = "Plugin-hrjf_Config_FrUri", description = "Plugin-hrjf_Config_FrUri_Description", status = Status.SHOW)
     private Conf<String> frUri = Holders.simple(StringKit.EMPTY);

     public static SsoConfig getInstance() {
         if (config == null) {
             config = ConfigContext.getConfigInstance(SsoConfig.class);
         }
         return config;
     }

     public String getUriBase() {
         return uriBase.get();
     }

     public void setUriBase(String uriBase) {
         this.uriBase.set(uriBase);
     }

     public String getClientId() {
         return clientId.get();
     }

     public void setClientId(String clientId) {
         this.clientId.set(clientId);
     }

     public String getClientSecret() {
         return clientSecret.get();
     }

     public void setClientSecret(String clientSecret) {
         this.clientSecret.set(clientSecret);
     }

     public String getFrUri() {
         return frUri.get();
     }

     public void setFrUri(String frUri) {
         this.frUri.set(frUri);
     }
 }