 /*
  * Copyright (C), 2018-2021
  * Project: starter
  * FileName: DateFormatEditor
  * Author:   Louis
  * Date:     2021/11/24 16:44
  */
 package com.fr.plugin.hrjf.editors;

 import com.fanruan.api.util.StringKit;
 import com.fr.design.Exception.ValidationException;
 import com.fr.design.mainframe.widget.editors.AbstractPropertyEditor;
 import com.fr.plugin.hrjf.items.DateFormatItems;
 import com.fr.plugin.hrjf.pane.DateFormatPane;

 import java.awt.*;
 import java.beans.PropertyChangeEvent;
 import java.beans.PropertyChangeListener;

 /**
  * <Function Description><br>
  * <DateFormatEditor>
  *
  * @author fr.open
  * @since 1.0.0
  */
 public class DateFormatEditor extends AbstractPropertyEditor {
     private final DateFormatPane dateFormatPane;

     public DateFormatEditor() {
         this.dateFormatPane = new DateFormatPane();
         this.initComponents();
     }

     private void initComponents() {
         this.dateFormatPane.addPropertyChangeListener("value", new PropertyChangeListener() {
             @Override
             public void propertyChange(PropertyChangeEvent evt) {
                 com.fr.plugin.hrjf.editors.DateFormatEditor.this.firePropertyChanged();
             }
         });
     }

     @Override
     public void validateValue() throws ValidationException {

     }

     @Override
     public Object getValue() {
         String value = this.dateFormatPane.update();
         return value;
     }

     @Override
     public void setValue(Object value) {
         if (StringKit.equals(String.valueOf(value), DateFormatItems.YEAR)) {
             this.dateFormatPane.populate(0, 0);
         } else if (StringKit.equals(String.valueOf(value), DateFormatItems.MONTH)) {
             this.dateFormatPane.populate(0, 1);
         } else if (StringKit.equals(String.valueOf(value), DateFormatItems.DATE)) {
             this.dateFormatPane.populate(0, 2);
         } else if (StringKit.equals(String.valueOf(value), DateFormatItems.DATES)) {
             this.dateFormatPane.populate(0, 3);
         } else if (StringKit.equals(String.valueOf(value), DateFormatItems.WEEK)) {
             this.dateFormatPane.populate(0, 4);
         } else if (StringKit.equals(String.valueOf(value), DateFormatItems.DATERANGE)) {
             this.dateFormatPane.populate(0, 5);
         } else if (StringKit.equals(String.valueOf(value), DateFormatItems.DATERANGEWEEK)) {
             this.dateFormatPane.populate(0, 6);
         } else if (StringKit.equals(String.valueOf(value), DateFormatItems.DATERANGEMONTH)) {
             this.dateFormatPane.populate(0, 7);
         } else if (StringKit.equals(String.valueOf(value), DateFormatItems.DATETIME)) {
             this.dateFormatPane.populate(1, 0);
         } else if (StringKit.equals(String.valueOf(value), DateFormatItems.DATETIMERANGE)) {
             this.dateFormatPane.populate(1, 1);
         } else {
             this.dateFormatPane.populate(0, 2);
         }
     }

     @Override
     public Component getCustomEditor() {
         return this.dateFormatPane;
     }
 }