 /*
  * Copyright (C), 2018-2021
  * Project: starter
  * FileName: ReturnTypeEditor
  * Author:   Louis
  * Date:     2021/11/12 11:16
  */
 package com.fr.plugin.hrjf.editors;

 import com.fanruan.api.design.DesignKit;
 import com.fanruan.api.util.StringKit;
 import com.fr.design.Exception.ValidationException;
 import com.fr.design.gui.ibutton.UIButtonGroup;
 import com.fr.design.mainframe.widget.editors.AbstractPropertyEditor;
 import com.fr.general.ComparatorUtils;

 import java.awt.*;
 import java.util.HashMap;
 import java.util.Map;

 /**
  * <Function Description><br>
  * <ReturnTypeEditor>
  *
  * @author fr.open
  * @since 1.0.0
  */
 public class ReturnTypeEditor extends AbstractPropertyEditor {
     public static final String STRING = "string";
     public static final String DATE = "date";
     private static final Map<String, String> ITEMS = new HashMap<String, String>() {
         {
             put(DesignKit.i18nText("Plugin-hrjf-Design_Form_Return_Type_String"), STRING);
             put(DesignKit.i18nText("Plugin-hrjf-Design_Form_Return_Type_Date"), DATE);
         }
     };
     protected UIButtonGroup<String> buttonGroup;

     public ReturnTypeEditor() {
         this.buttonGroup = new UIButtonGroup<>(ITEMS.keySet().toArray(new String[0]));
         this.initButtonGroupLookAndFeel();
     }

     @Override
     public void validateValue() throws ValidationException {

     }

     @Override
     public Object getValue() {
         if (ComparatorUtils.equals(this.buttonGroup.getSelectedIndex(), 0)) {
             return STRING;
         } else if (ComparatorUtils.equals(this.buttonGroup.getSelectedIndex(), 1)) {
             return DATE;
         } else {
             return STRING;
         }
     }

     @Override
     public void setValue(Object value) {
         if (StringKit.equals(String.valueOf(value), STRING)) {
             this.buttonGroup.setSelectedIndex(0);
         } else if (StringKit.equals(String.valueOf(value), DATE)) {
             this.buttonGroup.setSelectedIndex(1);
         } else {
             this.buttonGroup.setSelectedIndex(0);
         }
     }

     @Override
     public Component getCustomEditor() {
         return this.buttonGroup;
     }

     private void initButtonGroupLookAndFeel() {
         this.buttonGroup.addActionListener(e -> ReturnTypeEditor.this.firePropertyChanged());
     }
 }