 /*
  * Copyright (C), 2018-2021
  * Project: starter
  * FileName: FirstDayOfWeekItems
  * Author:   Louis
  * Date:     2021/11/15 8:42
  */
 package com.fr.plugin.hrjf.items;

 import com.fanruan.api.design.DesignKit;
 import com.fr.design.designer.properties.items.Item;
 import com.fr.design.designer.properties.items.ItemProvider;
 import com.fr.design.gui.icombobox.UIComboBox;

 import javax.swing.*;

 /**
  * <Function Description><br>
  * <FirstDayOfWeekItems>
  *
  * @author fr.open
  * @since 1.0.0
  */
 public class FirstDayOfWeekItems implements ItemProvider {
     public static final int SUNDAY = 7;
     public static Item[] VALUE_ITEMS = new Item[]{
             new Item(DesignKit.i18nText("Plugin-hrjf-Week_Start_Date_Monday"), 1),
             new Item(DesignKit.i18nText("Plugin-hrjf-Week_Start_Date_Tuesday"), 2),
             new Item(DesignKit.i18nText("Plugin-hrjf-Week_Start_Date_Wednesday"), 3),
             new Item(DesignKit.i18nText("Plugin-hrjf-Week_Start_Date_Thursday"), 4),
             new Item(DesignKit.i18nText("Plugin-hrjf-Week_Start_Date_Friday"), 5),
             new Item(DesignKit.i18nText("Plugin-hrjf-Week_Start_Date_Saturday"), 6),
             new Item(DesignKit.i18nText("Plugin-hrjf-Week_Start_Date_Sunday"), SUNDAY),
     };

     public FirstDayOfWeekItems() {
     }

     @Override
     public Item[] getItems() {
         return VALUE_ITEMS;
     }

     public static UIComboBox getUIComboBox() {
         return initUIComboBox(VALUE_ITEMS);
     }

     private static UIComboBox initUIComboBox(Item[] items) {
         DefaultComboBoxModel model = new DefaultComboBoxModel();
         for (Item item : items) {
             model.addElement(item);
         }
         return new UIComboBox(model);
     }
 }