;
;(function ($) {
    FR.VueDateTimeEditor = FR.extend(FR.DateTimeEditor, {
        _defaultConfig: function () {
            return $.extend(FR.VueDateTimeEditor.superclass._defaultConfig.apply(), {
                format: "yyyy-MM-dd",
                directEdit: true
            })
        },
        uuid: function () {
            var s = [];
            var hexDigits = "0123456789abcdef";
            for (var i = 0; i < 12; i++) {
                s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
            }
            var uuid = 'vue' + s.join("");
            return uuid;
        },
        _init: function () {
            try {
                FR.VueDateTimeEditor.superclass._init.apply(this, arguments);
                this._hideView();
                FR.$defaultImport('/com/fr/plugin/hrjf/css/index.min.css', 'css');
                var dom = this.element;
                var id = this.options.location = this.options.location || this.uuid();
                $(dom).attr("id", id);
                var d = $("#" + id)
                if (d[0]) {
                    this._realInit();
                } else {
                    this._initMe();
                }

                this.editComp.keydown(function (c) {
                    a.editComp[0].realValue = null
                });
                $(this.editComp).keyup(function () {
                    if ($(this).val() == a.oriText) {
                        return
                    }
                    a.isValidateInput();
                    a.oriText = $(this).val();
                    a.fireEvent(FR.Events.AFTEREDIT)
                });
            } catch (e) {
                console.error(e);
            }
        },
        onTriggerClick: function (a) {
            if (!this.isEnabled()) {
                return
            }
            if (document.activeElement != this.editComp[0]) {
                this.editComp.focus()
            }
            if (this.isExpanded()) {
                if (FR.Browser.isIE8() && this.$view.css("visibility") == "hidden") {
                    this.$view.css("visibility", "visible")
                } else {
                    this.$view.show()
                }
            } else {
                this.$view.empty();
                this._createCalendar()
            }
        },
        reportEdit: function () {
            var that = this;
            setTimeout(function () {
                that.fireEvent(FR.Events.AFTEREDIT);
            }, 300)
        },
        _realInit: function () {
            this._showView();
            $(this.element).css("overflow", "unset")
            console.log("%o", this);
            var opt = this.options;
            var id = opt.location;
            var dom = $('#' + id);
            // DatePicker日期选择器属性设置
            $(dom).html("<el-date-picker v-model=\"value1\"" +
                " type=\"date\" " +
                " placeholder=\"选择日期\"" +
                " value-format=\"timestamp\"" +
                " :picker-options=\"pickerOptions\"" +
                " ref=\"vueDateTime\"" +
                "></el-date-picker>\n"
            );
            var that = this;
            // var tmpValue = undefined
            // if (opt.value) {
            //     var t = opt.value.split(",");
            //     tmpValue = $.map(t, function (i) {
            //         return i;
            //     })
            // }
            // DatePicker日期选择器设置选项，后端配置项在opt中获得
            // 示例：周开始日期 firstDayOfWeek: opt.firstDayOfWeek
            var app = window.app = this.app = new Vue({
                    el: dom[0],
                    data: {
                        pickerOptions: {
                            disabledDate(time) {
                                return time.getTime() > Date.now();
                            },
                            shortcuts: [{
                                text: '今天',
                                onClick(picker) {
                                    picker.$emit('pick', new Date());
                                }
                            }, {
                                text: '昨天',
                                onClick(picker) {
                                    const date = new Date();
                                    date.setTime(date.getTime() - 3600 * 1000 * 24);
                                    picker.$emit('pick', date);
                                }
                            }, {
                                text: '一周前',
                                onClick(picker) {
                                    const date = new Date();
                                    date.setTime(date.getTime() - 3600 * 1000 * 24 * 7);
                                    picker.$emit('pick', date);
                                }
                            }],
                            firstDayOfWeek: opt.firstDayOfWeek
                        },
                        value1: '',
                        value2: '',
                    },
                    methods: {},
                    method: {
                        getValue: function () {
                            console.info(this.$refs.vueDateTime.model)
                        },
                    },
                    mounted: function () {
                    }
                }
            )
        },
        _initMe: function () {
            var id = this.options.location;
            var that = this;
            var intc = setTimeout(function () {
                var dom = $("#" + id);

                if (dom[0]) {
                    that._realInit();
                } else {
                    that._initMe();
                }
            }, 100)
        },
        setText: function (text) {
            this.editComp.val(text);
        },
        _hideView: function () {
            if (FR.Browser.isIE8()) {
                this.element.css("visibility", "hidden");
            } else {
                this.element.hide();
            }
        },
        _showView: function () {
            if (FR.Browser.isIE8()) {
                this.element.css("visibility", "show");
            } else {
                var id = this.options.location;
                $("#" + id).show();
            }
        },
        setValue: function (value) {
            try {
                if (value) {
                    this.app.$refs.vueDateTime.value = value;
                }
            } catch (e) {
                console.error(e);
            }
        },
        startEditing: function () {
            this._showView()
        },
        stopEditing: function () {
        },
        getValue: function () {
            if (this.app) {
                console.info("vueDateTime-getValue:" + this.app.$refs.vueDateTime.value);
                return this.app.$refs.vueDateTime.value;
            }
            return "";
        },
    });
    $.shortcut("vue_datetime", FR.VueDateTimeEditor);
})(jQuery);
(function ($) {
    !(function () {
        try {
            var provider = BI.Providers.getProvider("report.controller.provider");
        } catch (e) {
            return;
        }
        var ImplClass = provider.getImpl();
        var Widget = BI.inherit(ImplClass, {
            mounted: function () {
                this.widget = FR.createWidget(BI.extend({}, this.options, {
                    type: 'vue_datetime',
                    renderEl: this.element[0],
                }));

                Widget.superclass.mounted.apply(this, arguments);
            },
            isValidate:function (){
                return (this.widget && this.widget.isValidate.apply(this.widget, arguments))
            },
            focusDown: function () {
                return (this.widget && this.widget.focusDown.apply(this.widget, arguments))
            },
            getValue: function () {
                return (this.widget && this.widget.getValue.apply(this.widget, arguments))
            },
            reset: function () {
                return (this.widget && this.widget.reset.apply(this.widget, arguments))
            },
            preGetValidation: function () {
                return {result: this.isValidate.apply(this, arguments)}
            },
            postGetValidation: function () {
                return {result: this.isValidate.apply(this, arguments)}
            },
            setInteractValue: function () {
                this.widget && this.widget.setValue.apply(this.widget, arguments)
            },
            setControllerValue: function () {
                this.widget && this.widget.setValue.apply(this.widget, arguments)
            },
            resize: function (width, height) {
                this.widget && this.widget.doResize({
                    width: width, height: height
                });
            }
        });
        Widget.xtype = "vue_datetime";
        BI.shortcut(Widget.xtype, Widget);
        provider.set('vue_datetime', Widget.xtype);
    })();
})(jQuery);